:- module( cultivate_basic_metrics, [
			  metric/4,
			  metric/3
		  ]).

:- dynamic  cached_metric/3.

/* Role metrics
 * metric(+MetricName, ?MetricID, -MetricValue, -RangeAndThreshold) /4
 * metric(+MetricName, ?MetricID, -MetricValue)    /3
*/
metric(MetricName, MetricID, MetricValue, RangeAndThreshold) :-
    ground(MetricID),
    cached_metric(MetricName,MetricID, MetricValue), 
    !,
    metric_attributes(MetricName,RangeAndThreshold).
    
metric(MetricName, MetricID, MetricValue, RangeAndThreshold) :-
    not(ground(MetricID)),
    cached_metric(MetricName,MetricID, MetricValue),
    metric_attributes(MetricName,RangeAndThreshold).    

metric(MetricName, MetricID, MetricValue, RangeAndThreshold) :-
    metric_(MetricName,MetricID, MetricValue),
    not(cached_metric(MetricName,MetricID, _)),
    assert(cached_metric(MetricName,MetricID, MetricValue)),
    metric_attributes(MetricName,RangeAndThreshold).

metric(MetricName,MetricID, MetricValue) :-
	metric(MetricName,MetricID, MetricValue, _).
	
