:- module( cultivate_basic_relationsmells, [
			  relation_smell/3
		   ]).
		  
:- dynamic  cached_relation_smell/3.

/* Relation smells
   relation_smell(+SmellName, -FirstParticipant, -SecondParticipant)
*/
relation_smell(SmellName, FirstParticipant, SecondParticipant) :-
    ground(FirstParticipant),
    ground(SecondParticipant),
    cached_relation_smell(SmellName, FirstParticipant, SecondParticipant),
    !.
    
relation_smell(SmellName, FirstParticipant, SecondParticipant) :-
    not(ground(FirstParticipant)),
    not(ground(SecondParticipant)),
    cached_relation_smell(SmellName, FirstParticipant, SecondParticipant)
    .    
    
relation_smell(SmellName, FirstParticipant, SecondParticipant) :-
    relation_smell_(SmellName, FirstParticipant, SecondParticipant),
    assert(cached_relation_smell(SmellName, FirstParticipant, SecondParticipant)).

  
