/**
* field_is_inherited(+FieldID)
*
* Returns true if given field is inherited from a super class of its owner class, else false.
* If no FieldID is given, the ID of an inherited field will be returned. 
*/
field_is_inherited(FieldID) :-
	fieldT(FieldID, ClassID, FieldType, FieldName, _),
	real_subtype(ClassID, SuperClassID),
	type_contains_field(SuperClassID,SuperFieldID),
	can_access_field(ClassID, SuperFieldID),
	fieldT(SuperFieldID, SuperClassID, FieldType, FieldName, _).

	
