/**
* field_is_pseudo_final(+FieldID)
* succeeds if field with FieldID is "final": 
*                    it is initialized but nowhere assigned,
*                 or it is not initialized and exactly once assigned
*/
field_is_pseudo_final(FieldID) :-
    initialized(FieldID),
    number_of_assignments(FieldID, 0).

field_is_pseudo_final(FieldID) :-
    not(initialized(FieldID)),
    number_of_assignments(FieldID, 1).