/**
 * getter_method(+MethodID)
 *	
 * This predicate will be true, if the Method 
 * with the ID "MethodID" is a getter-Method
 */
getter_method(MethodID) :-
    % method has no parameters
    methodDef(MethodID,_,MethodName,[],MethodType,_,_),
    %Return type must not be void
    not(MethodType == type(basic, 'void', _)),
    %Method name must be get*....()
	(
    	(atom_concat('get',_,MethodName), !)
    	;
    	(atom_concat('is',_,MethodName), !)
    ).
	
	% TODO: This check is not strict enough.
	% We could check that the return statement 
	% returns a field of the ReturnType.
	
/**
 * getter_method(+MethodID, -Attribute)
 *	
 * This predicate will be true, if the Method 
 * with the ID "MethodID" is a getter-Method and Attribute will be the FieldID used by the getter
 */
getter_method(MethodID, Attribute) :-	
    methodDef(MethodID,ClassID,MethodName,[], MethodType, _, BlockID),
    (
    	(atom_concat('get',_,MethodName), !)
    	;
    	(atom_concat('is',_,MethodName), !)
    ),
    not(MethodType == type(basic, 'void', _)),
    blockT(BlockID,_,_,Statements),
    member(ReturnID,Statements),
    returnT(ReturnID,BlockID,MethodID,GetFieldID),
    getFieldT(GetFieldID,ReturnID,MethodID,_,VarName,Attribute),
    fieldT(Attribute,ClassID,_,VarName,_).
