/**
 * setter_method(+Method)
 *	
 * Method is a Method with one parameter, return type void, 
 * and its name starts with "set".
 */
setter_method(Method) :-
    methodDef(Method,_, Name, [_], type(basic, 'void', _), _, _),   
	atom_concat('set', _, Name).
	
/**
 * setter_method(+MethodID, -Attribute)
 *	
 * This predicate will be true, if the Method 
 * with the ID "MethodID" is a setter-Method and Attribute is the FieldID  used by the setter
 */
setter_method(MethodID, Attribute) :-	
    methodDef(MethodID, ClassID, MethodName, [ParameterId], type(basic, 'void', _) ,_,BlockID),
    atom_concat('set',_,MethodName),
    blockT(BlockID,_,_,Statements),
    member(ExecId,Statements),
    execT(ExecId, _, MethodID, AssignID),
    assignT(AssignID, _, MethodID, GetFieldID, _),
    paramT(ParameterId, MethodID, FieldType, _),
    getFieldT(GetFieldID, AssignID, MethodID, _, _, Attribute),
    fieldT(Attribute, ClassID, FieldType, _, _).
