/**
 *	trivial_getter_method(+MethodID)
 *	
 *	This predicate will be true, if the method with the ID "MethodID" is a 
 *  trivial getter-Method.
 *
 *  example (for field "int x;"): 
 *
 *  public int getX() {
 *    return x;
 *  }
 */
trivial_getter_method(MethodID) :-
    methodDef(MethodID,_,MethodName,MethParams,MethodType,_,Body),
    not(MethodType == type(basic, 'void', _)),
    length(MethParams, 0),
    blockT(Body,_,_,Statements),
    length(Statements,1),
	atom_concat('get',_,MethodName).