/**
 *	trivial_setter_method(+Method)
 *	
 *	This predicate will be true, if the method with the ID "Method" is a 
 *  trivial getter-Method.
 *
 *  example (for field "int x;"): 
 *
 *  public void setX(int x) {
 *    this.x = x;
 *  }
 */
trivial_setter_method(Method) :-
    methodDef(Method,_, MethodName, [_], type(basic, 'void', _), _, Body),
    blockT(Body,_,_,Statements),
    length(Statements,1),
	atom_concat('set',_,MethodName).
	
	% TODO: We could be more precise here.