/**
* declared_in_interface(?MethodID)
*
* Checks if method is declared in an interface which is implemented by its class.
*/
declared_in_interface(MethodID) :-
    methodDef(MethodID, InterfaceID, _, _, _, _, _),
    interfaceT(InterfaceID).

declared_in_interface(MethodID) :-
    methodDef(MethodID, ClassID, _, _, _, _, _),
    same_signature(MethodID, InterfaceMethodID),
    methodDef(InterfaceMethodID, InterfaceID, _, _, _, _, _),
    interfaceT(InterfaceID),
    implements_interface(ClassID, InterfaceID).
