/**
* equal_parameters(+ParameterIDs1, +ParameterIDs2)
*
* Checks that type and name of the parameters are equal (same order is required).
*/
equal_parameters([],[]).
   
equal_parameters([H1|T1], [H2|T2]):-
    paramT(H1, _, Type, Name),
    paramT(H2, _, Type, Name),
	equal_parameters(T1,T2).    

/**
 * equal_parameter_types(+ParameterIDs1,+ParameterIDs2)
 *
 * Checks that the types of the parameters are equal (same order is required).
 */
equal_parameter_types([],[]).

equal_parameter_types([H1|T1],[H2|T2]) :-
    paramT(H1, _, Type, _),
    paramT(H2, _, Type, _),
	equal_parameter_types(T1,T2).

/**
* equal_parameters_subset(+ParameterIDs1, +ParameterIDs2)
*
* Checks that the types and names of the parameters are equal.
* ParameterIDs2 is allowed to contain more parameters than ParameterIDs1.
*/
equal_parameters_subset([], []).

equal_parameters_subset([], [_|_]).

equal_parameters_subset([H1|T1], [H2|T2]) :-
    paramT(H1, _, Type, Name),
    paramT(H2, _, Type, Name),
	equal_parameters_subset(T1,T2).

