/**
 * method_calls_method(+CallingMethodId, ?CalledMethodId)
 *
 * Tests whether the CalledMethod is called by CallingMethod.
 *
 * ASSUMES: CallingMethodId and CalledMethodId are Ids of some methods.  
 */
method_calls_method(CallingMethodId,CalledMethodId):-
    ri_callT_encl(CallingMethodId,Id),
    callT(Id,_,CallingMethodId, _, _, _, CalledMethodId).

method_calls_method(CallingMethodId,CalledMethodId):-
    ri_newClassT_encl(CallingMethodId,Id),
    newClassT(Id,_,CallingMethodId,CalledMethodId, _, _, _,_).

/**
 * method_calls_method_transitive(+CallingMethodId, ?CalledMethodId)
 *
 * Tests whether the CalledMethod is called by CallingMethod, transitive.
 *
 * ASSUMES: CallingMethodId and CalledMethodId are Ids of some methods.  
 */
    
method_calls_method_transitive(CallingMethodId,CalledMethodId) :-
    method_calls_method(CallingMethodId,CalledMethodId).
    
method_calls_method_transitive(CallingMethodId,CalledMethodId) :-
    method_calls_method(CallingMethodId,IntermediateMethod),
    method_calls_method_transitive(IntermediateMethod,CalledMethodId).    