/*
* method_modifier(+MethodID, ?Modifier)
*
* gets the modifiers of given method or
* checks if given modifier belongs to specified method.
*/
method_modifier(MethodID, Modifier) :-
    methodDef(MethodID, _, _, _, _, _, _),
    modifierT(MethodID, Modifier),
    modifier(Modifier).

method_modifier(MethodID, Modifier) :-
    methodDef(MethodID, ClassID, _, _, _, _, _),
    not(
    	(
    		modifierT(MethodID, Modifier),
    		modifier(Modifier)
    	)
    ),
    interfaceT(ClassID),
    Modifier = abstract.

