%Computes the connected components of a Graph given in adjazenenz list representation

%compute_connected_components_(+AdjazenzList,-Components)
compute_connected_components_(AdjazenzList,Components):-
    findall(Method,member(Method-_,AdjazenzList),MethodIDs),
    connected_components__(AdjazenzList,MethodIDs,Components).

connected_components__(AdjazenzList,MethodIDs,Components):- 
    [CurrentMethodID|_] = MethodIDs,
    reachable(CurrentMethodID, AdjazenzList, Reachable),
    subtract(MethodIDs,Reachable, RemainingMethods),
    connected_components__(AdjazenzList,RemainingMethods,ComponentsNext),
    append([Reachable],ComponentsNext,Components).
    
connected_components__(_,[],[]).