/**
* method_name(+MethodID, ?Name) /2
* succeeds if Arg1 is the method ID of the identifier with name Arg2 
**/
method_name(MethodID,Name):- methodDef(MethodID, _, Name, _, _, _, _).

/**
* method_name(+TypeID, ?Name) /2
* succeeds if Arg1 is the method ID of the identifier with name Arg2 
**/
type_name(TypeID,Name) :- classT(TypeID, _, Name, _).

/**
* package_name(+PackageID, ?Name) /2
* succeeds if Arg1 is the package ID of the identifier with name Arg2 
**/
package_name(PackageID,Name) :- packageT(PackageID, Name). 

/**
* field_name(+FieldID, ?Name) /2
* succeeds if Arg1 is the field ID of the identifier with name Arg2 
**/
field_name(FieldID,Name) :- fieldT(FieldID, _,_,Name,_). 



/**
* parameter_names(?MethodID, ?ParameterNames)
*
* Maps method id with belonging parameter ids.
* Gets parameter names for given method id or
* gets method for given parameter names.
*/
parameter_names(MethodID, ParameterNames) :-
    methodT(MethodID, _, _, ParamIDs, _, _, _),
    maplist(parameter_name, ParamIDs, ParameterNames).

parameter_names(MethodID, ParameterNames) :-
    constructorT(MethodID, _, ParamIDs, _, _),
    maplist(parameter_name, ParamIDs, ParameterNames).

/**
* parameter_name(?ParameterID, ?Name)
*
* Gets the name of given parameter or
* gets parameter id for given name.
*/
parameter_name(ParameterID, Name) :-
    paramT(ParameterID, _, _, Name).

							