%:- module(cultivate_concepts, []).

cultivate_concept_location_fact.

:- consult(term_vocabulary/load).

:- use_module(words/load).
:- use_module(util/utilities_module).
:- use_module(quantity/quantity_module).
:- use_module(schlachter/pronto_module).

:- consult(categorization/load).
:- consult(metrics/metrics_module).

%term_introduction(Context,Term):- 
%	type(Context), 
% 	type_name(Context,ContextName),
% 	context_has_lexical(Context,ContextName).
 	
%term_use(Context,Term,DependingContext) :- 	
%	context_has_lexical(Context,Term), 
%	not(term_introduction(Context,Term)),
%	term_introduction(DependingContext,Term),
%	static_code_path(Context,DependingContext).

relevant(Count):-
   count((classT(A,_,_,_), not(cultivate_concepts_term_cache_generation:is_extern(classT,A))),Classes),
   count((packageT(A,_), not(cultivate_concepts_term_cache_generation:is_extern(packageT,A))),Packages),
   count((methodT(A,_,_,_,_,_,_), not(cultivate_concepts_term_cache_generation:is_extern(methodT,A))),Methods),
   count((constructorT(A,_,_,_,_), not(cultivate_concepts_term_cache_generation:is_extern(constructorT,A))),Constructors),
   Count is Classes + Packages + Methods + Constructors.
								   