:- multifile termmetric/4.
:- multifile query_description/3.

query_description(termfrequency,termmetric, 'Returns two list with the terms and their corresponding nr of occurence').

/** 
*  termmetric_(termfrequency,+Scope, -ContextID , -TermFrequencies)
*  Returns the term frequencies for the given scope, scope can be packageT,classT,methodDef
*  The returned list contains also if a term is introduced in this context.
**/
termmetric(termfrequency,Scope, ContextID , TermFrequencies) :-
   once(term_metrics:metric_precondition),
   ast_node_type_value(ContextID,Scope), 
   not(externT(ContextID)), 
   term_frequency_query__(ContextID, TermFrequencies).    

/**
* term_frequency_query__(+Context, -TermFrequencies)
* Returns all term frequencies for the given context Id. 
* Additionally this contains if a term is introduced in this context.
**/   
term_frequency_query__(Context, TermFrequencies) :-
   findall( 
       [Term, TF, IsIntroducedInContext],
        (cached_term_metrics_tf(Context,Term,TF),
         is_term_introduced(Context,Term, IsIntroducedInContext)),
       TermFrequencies
   ).
  


	    