:- module( term_stems, [
		match_stem/3,
		fill_stems/0,
		clear_stems/0
    ] ).
:- dynamic cached_term_stem/2. % (Stem,Term,Context)    
:- dynamic cached_stem/2.
% Use the porter stem library, needs to be included for the stem functionality
%:- use_module(library(porter_stem)).
assert_unique(Fact) :- 
   once(Fact) -> true ; assert(Fact).
   
report_term_cache_contents_statistics :-
   forall( 
     dynamic_local_predicate(Head),
     ( functor(Head,Functor,Arity),
       count(Head,Count),
       format('~a  term stem cache entries for ~w.~n', [Count,Functor/Arity])
     ) 
   ).



fill_stems:-
		cached_occurrences_of_term_in_context(_Context,Term,_),
		porter_stem(Term,Stem),
			assert_unique(cached_term_stem(Stem,Term)),
		fail.
fill_stems.

% Retracts all cached stems
clear_stems:-
	  retractall( cached_term_stem(_,_,_)).

% match_stem(?Stem,?Term1,?Term2)
% Succeeds if Term1 and Term2 have the same Stem
match_stem(Stem,Term1,Term2):-
	  cached_term_stem(Stem,Term1),
	  cached_term_stem(Stem,Term2),
	  not(Term1 == Term2).


print_stems:-
      cached_term_stem(Stem,_),
      findall(Term, (cached_term_stem(Stem,Term)), Terms),
      	assert_unique(cached_stem(Stem,Terms)),
      fail.
print_stems.

print_stems2:-
	  cached_stem(Stem,Terms),
	  format('~w ~t ~t; ~w ~n',[Stem,Terms]),
	  fail.
print_stems2.	  		  		  
/**
remove_extern:-
      externT(ContextID),
      ast_node_sub_trees(_,ContextID,ListOfIDs),
      removechilds__(ListOfIDs),
      temp_remove(ContextID),
     fail.
remove_extern.

removechilds__([]).
removechilds__([H|T]):- 
		temp_remove(H),
		removechilds__(T).

temp_remove(ID):-
     ast_node_for_id(ID,_,PEF),
     user:retract(PEF),
     user:retract(externT(ID)).
     %format('Retracting ~w ~n',[PEF]).	
*/		     