write_to_csv_file__ :-
    		  open('test.csv',write,Stream),
    		  format(Stream,' "FQN" ; "MethodName"; "Visibility" ; "Name Length" ; "ScopeValue" ; "ScopeVariant"; "#Calls" ; "SumSurprise" ; "Surprising Terms"~n',[]),
			  catch( temp__(Stream) ,_,true),
			  close(Stream).
			  	 
temp__(Stream) :- 
				  internal_method(MethodID),
				  not(is_constructor(MethodID)),
					  full_qualified_name_javaelement(MethodID,FQN),				  
					  method_name(MethodID,MethodName),
				      name_length(MethodID,NameLength),
				      semantic_scope(MethodID,Scope),
				      semantic_scope_variant(MethodID,VariantScope),
				      visibility(MethodID, Access),
				      number_of_method_calls(MethodID,NoMC),
				      surprising_terms_for_context(MethodID,SurprisingTerms),
				      surprise_of_context(MethodID,Surprise),
    			   	  format(Stream,' "~w" ; "~w" ; "~w" ; ~d ; ~d ; ~d ; ~d ; ~f ; "~w" ~n',[FQN,MethodName,Access,NameLength,Scope,VariantScope,NoMC,Surprise,SurprisingTerms]),
    			   	 % format(' "~w" ; "~w" ; "~w" ; ~d ; ~d ; ~d ; ~d ; ~f ; "~w" ~n',[FQN,MethodName,Access,NameLength,Scope,VariantScope,NoMC,Surprise,SurprisingTerms]),
    		   	  fail.
temp__(_).    		   
               				
/**
* match_not_found_ids__(-NotFoundMethodIDs)
* find all not matched method ids of write_to_csv_file
**/               				
match_not_found_ids__(NotFoundMethodIDs) :-  findall(MethodID, 
				( internal_method(MethodID),
				  not(is_constructor(MethodID)),
					  full_qualified_name_javaelement(MethodID,_),				  
					  method_name(MethodID,_),
				      name_length(MethodID,_),
				      semantic_scope(MethodID,_),
				      semantic_scope_variant(MethodID,_),
				      visibility(MethodID, _),
				      number_of_method_calls(MethodID,_)),
				  ListOfFoundMethodIDs),
				  
				  findall(MethodID, 
				  (internal_method(MethodID),
				  not(is_constructor(MethodID))),
				  ListInternalMethods),
				  
				  subtract(ListInternalMethods,ListOfFoundMethodIDs,NotFoundMethodIDs).    
               				