:- multifile query_description/3.
:- multifile metric_/3.
:- multifile metric_attributes/2.

query_description(abstractness,metric, 'improved ratio of abstract classes').
metric_attributes(abstractness, float(range(0,1), defaultthresholds(0,1))).

/**
* abstractness(+PackageID, ?ReturnValue, )
   
* Returns the abstractness of a package PackageId/PackageName.
* uses the improved abstractness instead of rc martin abstractness
*/
metric_(abstractness, PackageID, ReturnValue) :-
    internal_package(PackageID),
    improvedAbstractness(PackageID, ReturnValue).


/**
* rcm_abstractness(+PackageID, ?ReturnValue, )
   
* Returns the abstractness of a package PackageId/PackageName.
* uses the rc martin abstractness
*/
query_description(rcm_abstractness,metric, 'ratio of abstract classes').
metric_attributes(rcm_abstractness, float(range(0,1), defaultthresholds(0,1))).

metric_(rcm_abstractness, PackageID, ReturnValue) :-
    internal_package(PackageID),
    rcmartinAbstractness(PackageID, ReturnValue).