:- multifile query_description/3.
:- multifile metric_/3.
:- multifile metric_attributes/2.

query_description(instability, metric, 'degree of instability').
metric_attributes(instability, float(range(0,1), defaultthresholds(0,1))).

/** *****************************************************************
  * instability(+PackageId, ?Instability)
  *
  * Returns the ratio of efferent couplings to total number of
  * (afferent and efferent) couplings for the package
  * PackageId/PackageName.
  * If the package has no couplings at all it returns 0.
  */
metric_(instability, PackageID, Instability) :-
    internal_package(PackageID),
    metric(afferentCouplings, PackageID, AfferentClasses),
    metric(efferentCouplings, PackageID, EfferentClasses),
    AllReferenceClasses is AfferentClasses + EfferentClasses,
    divide(EfferentClasses,AllReferenceClasses,Instability,0).